<template>
  <v-dialog
      v-model="dlgMsg"
      persistent
      transition="dialog-top-transition"
      max-width="300"
  >
    <v-card>
      <v-card-title class="headline" v-text="title != null ? title : 'INFORMASI'">
      </v-card-title>
      <v-card-text v-text="message" />
      <v-card-actions>
        <v-spacer />
        <v-btn
            color="blue darken-1"
            text
            @click="doOkMsg"
            v-text="'YES'"
            v-if="isConfirm && !showButton"
        />
        <v-btn
            v-if="!showButton"
            :color="isConfirm ? 'red darken-1' : 'green darken-1'"
            text
            @click="doCloseMsg"
            v-text="!isConfirm ? 'Close' : 'NO'"
        />
        <v-btn
            v-if="showButton"
            color="blue darken-1"
            text
            @click="showProgress"
            v-text="'Show Progress'"
        />
        <v-spacer />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  name: "DlgMsg",
  data: function () {
    return {
      resolve: null,
      reject: null,
      title: null,
      message: null,
      dlgMsg: false,
      isConfirm: false,
      showButton: false,
      param: null,
    }
  },
  methods: {
    showProgress() {
      this.dlgMsg = false
      window.open(`/progress/batch/${this.param}`, '_blank')
    },
    doOpenMsg(message, title = null, param = null, showButton = false) {
      this.message = message
      this.title = title
      this.param = param
      this.isConfirm = false
      this.dlgMsg = true
      this.showButton = showButton
    },
    confirm(message) {
      this.message = message
      this.title = 'KONFIRMASI'
      this.isConfirm = true
      this.dlgMsg = true
      return new Promise((resolve, reject) => {
        this.resolve = resolve;
        this.reject = reject;
      });
    },
    doOkMsg() {
      this.resolve(true)
      this.dlgMsg = false
    },
    doCloseMsg() {
      if (this.isConfirm) {
        this.resolve(false)
      }
      this.dlgMsg = false
    }
  }
}
</script>

<style scoped>

</style>